<?php
/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/Resources/Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

namespace Sugarcrm\Sugarcrm\PackageManager\Exception;

use ModuleScanner;
use SugarException;

class PackageManagerException extends SugarException
{
    public $moduleName = 'Administration';

    public function setErrorDescription($data): self
    {
        $this->setExtraData('error_description', $data);
        return $this;
    }

    /**
     * @var ModuleScanner
     */
    protected $moduleScanner;

    /**
     * @return ModuleScanner
     */
    public function getModuleScanner(): ModuleScanner
    {
        return $this->moduleScanner;
    }

    /**
     * @param ModuleScanner $moduleScanner
     * @return $this
     */
    public function setModuleScanner(ModuleScanner $moduleScanner): PackageManagerException
    {
        $this->moduleScanner = $moduleScanner;
        return $this;
    }
}
